<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101, 102, 103))) {

    if (!empty($_POST['del'])) {

        $del = intar($_POST['del']);

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            if ($del > 0) {

                $del = is_array($del) ? $del : array($del);

                $del = implode(',', $del);

                $db->query("DELETE FROM ?_comments WHERE `comm_type` = 'blog' AND `comm_id` IN(" . $del . ")");

                $db->query("UPDATE ?_blog_posts SET `blog_comments` = (SELECT COUNT(1) FROM ?_comments WHERE ?_blog_posts.`blog_id` = ?_comments.`comm_post` AND `comm_type` = 'blog');");

                $inSes->addMessage('Выбранные комментарии в блогах успешно удалены!', 'ok');
            }
            else $inSes->addMessage('Ошибка! Отстутствуют выбранные комментарии для удаления!');
        }
        else $inSes->addMessage('Ошибка! Неверный идентификатор сессии, повторите действие!');

        redirect('?m=comments&' . RND);
    }

    show_header('Последние комментарии');

    $onpage = !empty($config['comm_num']) ? num($config['comm_num']) : 10;

    if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

    $_SESSION[SP]['comm'] = !empty($_SESSION[SP]['comm']) ? num($_SESSION[SP]['comm']) : 2;

    $_SESSION[SP]['comm'] = (!empty($_GET['sort']) && in_array($_GET['sort'],array(1,2))) ? num($_GET['sort']) : num($_SESSION[SP]['comm']);

    $order = ($_SESSION[SP]['comm'] == 1) ? 'DESC' : 'ASC';

    $type = 'all';

    if ($type == 'all') {

        $coms = $db->selectPage( $total, "SELECT `c`.*, `v`.`visit_nowtime`, `u`.`users_id`, `u`.`users_gender`
                                          FROM ?_comments `c` LEFT JOIN ?_users `u`
                                          ON `c`.`comm_author` = `u`.`users_login`
                                          LEFT JOIN ?_users_visit `v`
                                          ON `c`.`comm_author` = `v`.`visit_user`
                                          ORDER BY `c`.`comm_date` " . $order . " 
                                          LIMIT ?d, ?d", $from, $onpage );
    }
    else {

        $coms = $db->selectPage( $total, "SELECT `c`.*, `v`.`visit_nowtime`, `u`.`users_id`, `u`.`users_gender`
                                          FROM ?_comments `c` LEFT JOIN ?_users `u`
                                          ON `c`.`comm_author` = `u`.`users_login`
                                          LEFT JOIN ?_users_visit `v`
                                          ON `c`.`comm_author` = `v`.`visit_user`
                                          WHERE `c`.`comm_type` = ?
                                          ORDER BY `c`.`comm_date` " . $order . " 
                                          LIMIT ?d, ?d", $type, $from, $onpage );
    }

    echo '<div class="bl"><span><b>Комментарии</b> (' . num($total) . ')</span><br />';
    echo 'Показывать новые: ';
    if ($_SESSION[SP]['comm'] == 1) echo '<a href="?m=comments&amp;sort=2&amp;' . RND . '">вверху</a> | <b>внизу</b>';
    else echo '<b>вверху</b> | <a href="?m=comments&amp;sort=1&amp;' . RND . '">внизу</a>';	
    echo '</div>';

    if (!empty($coms) && $total > 0) {

        echo '<form action="?m=comments&amp;rnd=' . $_SESSION['token'] . '" method="post" name="comments">';

        $i = $from + 1;

        foreach ($coms as $numCom => $com) {

            echo '<div class="bl">';
            echo '<table class="w100"><tr>';
            echo '<td class="vhr" valign="top">' . user_avatars($com['comm_author']) . '';
            echo '<br /><input type="checkbox" name="del[]" value="' . num($com['comm_id']) . '" />';
            echo '</td><td valign="top">';
            echo '<span class="fr xsmall">' . get_date(strtotime($com['comm_date'])) . '</span>';
            echo user_visit_icon($com['comm_author'], $com['users_gender'], $com['visit_nowtime']);
            echo ' ' . users_anketa($com['users_id'], $com['comm_author']) . '<hr />';
            echo nl2br(bb_code($com['comm_text'])) . '</td></tr></table></div>';
        }

        echo show_pages('?m=comments&amp;type=' . $type);

        echo '<div class="bl">&nbsp;';
        echo '<input type="checkbox" name="master_box" title="Отметить всё" onclick="javascript:ckeck_uncheck_all()"> ';
        echo '<input type="submit" class="btns" value="Удалить выбранное" /></form></div>';

            echo <<<JSCRIPT

<script language='JavaScript' type="text/javascript">
<!--
function ckeck_uncheck_all() {
    var frm = document.comments;
    if(frm.master_box.checked == true){ frm.master_box.checked = false; }
    else{ frm.master_box.checked = true; }
    for (var i=0;i<frm.elements.length;i++) {
        var elmnt = frm.elements[i];
        if (elmnt.type=='checkbox') {
            if(frm.master_box.checked == true){ elmnt.checked=false; }
            else{ elmnt.checked=true; }
        }
    }
}
-->
</script>

JSCRIPT;

    }
    else {

        show_error('Комментарии не найдены!');
    }

    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

    show_footer();
}
else {

    redirect('/?' . RND);
}

?>