<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101, 102))) {

    define('MAT_FILE', ENGINE . '/data/mat.dat');

    $onpage = 30; // Матов на страницу

    if (!empty($_POST['add'])) {

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            if (!empty($_POST['name'])) {

                $mat = check($_POST['name']);
                $mat = preg_replace("|[\r\n]+|si", "", $mat);

                if ($fp = fopen(MAT_FILE, 'a+')) {

                    flock ($fp,LOCK_EX);
                    fputs($fp,"$mat\n");
                    flock ($fp,LOCK_UN);
                    fclose($fp);
                    @chmod($fp, 0777);
                    @chmod(MAT_FILE, 0777);
                }
                else $inSes->addMessage('Ошибка! Не удалось открыть файл!');
            }
            else $inSes->addMessage('Ошибка! Вы не ввели слово!');
        }
        else $inSes->addMessage('Неверный идентификатор сессии, повторите действие!');

        redirect('?m=mat&' . RND);
    }

    if (!empty($_GET['del'])) {

        if ($_GET['del'] == $_SESSION['token']) {

            $file = @file( MAT_FILE );

            if (!empty($file)) {

                $fp = fopen(MAT_FILE, 'w');
                flock ($fp,LOCK_EX);
                for ($i=0;$i< sizeof($file);$i++) { if ($i==$id) {unset($file[$i]);} }
                fputs($fp, implode("",$file));
                flock ($fp,LOCK_UN);
                fclose($fp);

                $inSes->addMessage('Мат успешно удалён!', 'ok');
            }
            else $inSes->addMessage('Ошибка! Не удалось открыть файл!');
        }
        else $inSes->addMessage('Неверный идентификатор сессии, повторите действие!');

        redirect('?m=mat&page=' . $page . '&' . RND);
    }

    show_header('Управление матом');

    if ( @file_exists( MAT_FILE ) ) {

        $file = @file( MAT_FILE );

        if (!empty($file)) {

            $file = @array_reverse($file);
            $total = count($file);

            if ($total > 0) {

                list($start, $stop) = get_page();

                for ($i = $start; $i < $stop; $i++) {

                    if (empty($file[$i])) continue;

                    $num = $total - $i - 1;

                    echo '<div class="bl">' . ($i + 1) . '. <b>' . $file[$i] . '</b> <span class="fr xsmall">';
                    echo '<a href="?m=mat&amp;id=' . $num . '&amp;page=' . $page . '&amp;del=' . $_SESSION['token'] . '">Удалить</a>';
                    echo '</span></div>';
                }

                echo show_pages('?m=mat');

                echo '<div class="bl">Всего мата: <b>' . $total . '</b></div>';
            }
            else {

                show_error('Мата пока ещё нет!');
            }
        }
        else {

            show_error('Мата пока ещё нет!');
        }
    }
    else {

        show_error('Мата пока ещё нет!');
        @file_put_contents(MAT_FILE, '');
        @chmod($fp, 0777);
        @chmod(MAT_FILE, 0777);
    }

    echo '<div class="bl">';
    echo '<form action="?m=mat&amp;rnd=' . $_SESSION['token'] . '" method="post">';
    echo '<b>Слово:</b> ';
    echo '<input type="text" name="name" maxlength="50" /> ';
    echo '<input type="submit" name="add" class="btns" value="Добавить" /></form></div>';

    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

    show_footer();
}
else {

    redirect('/?' . RND);
}

?>