<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101))) {

    if (!defined('CFG_FILE')) define( 'CFG_FILE', ENGINE . '/data/config.ini' );

    $cfg = ini::read( CFG_FILE );

    if (!empty($_GET['default'])) {

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            if ( @file_exists( ENGINE . '/data/config_tmp.ini' ) ) {

                $new = ini::read( ENGINE . '/data/config_tmp.ini' );

                if ( $new ) {

                    $new['db_host']    = $cfg['db_host'];
                    $new['db_user']    = $cfg['db_user'];
                    $new['db_pass']    = $cfg['db_pass'];
                    $new['db_name']    = $cfg['db_name'];
                    $new['db_prefix']  = $cfg['db_prefix'];
                    $new['db_collate'] = $cfg['db_collate'];
                    $new['site_url']   = $cfg['site_url'];
                    $new['login']      = $cfg['login'];
                    $new['email']      = $cfg['email'];
                    $new['nickname']   = $cfg['nickname'];

                    ini::save( CFG_FILE, $new );

                    $inSes->addMessage('Настройки по умолчанию успешно восстановлены!', 'ok');

                }
                else $inSes->addMessage('Ошибка! Не удалось открыть файл!');
            }
            else $inSes->addMessage('Ошибка! Файл настроек не найден!');
        }
        else $inSes->addMessage('Ошибка! Неверный идентификатор сессии, повторите действие!');

        redirect('?m=set&' . RND);
    }

    show_header('Настройки сайта');

    echo '<div class="link"><a href="?m=set_general">Основные настройки</a></div>';
    echo '<div class="link"><a href="?m=set_personal">Личные настройки</a></div>';
    echo '<div class="link"><a href="?m=set_chat">Настройки чата</a></div>';
    echo '<div class="link"><a href="?m=set_blog">Настройки блогов</a></div>';
    echo '<div class="link"><a href="?m=set_reg">Настройки регистрации</a></div>';
    echo '<div class="link"><a href="?m=set_mail">Настройки отправки почты</a></div>';
    echo '<div class="link"><a href="?m=set_other">Разные настройки</a></div>';
    echo '<div class="link"><a href="?m=set_shop">Настройки цен</a></div>';
    echo '<div class="link"><a href="?m=set&amp;default=1&amp;rnd=' . $_SESSION['token'] . '">Вост. настр. по умолчанию</a></div>';
    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

}
else {

    redirect('/?' . RND);
}

?>