<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101))) {

    if (!defined('CFG_FILE')) define( 'CFG_FILE', ENGINE . '/data/config.ini' );

    $cfg = ini::read( CFG_FILE );

    if (!empty($_POST['submit'])) {

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            unset($_POST['submit']);

            $check_mail_config = !empty($_POST['check_mail_config']) ? 1 : 0;

            unset($_POST['check_mail_config']);

            if ($check_mail_config === 1) {

                $config['mailer']            = request('mailer');
                $config['mailer_host']       = request('mailer_host');
                $config['mailer_port']       = request('mailer_port');
                $config['mailer_smtpauth']   = request('mailer_smtpauth');
                $config['mailer_smtpsecure'] = request('mailer_smtpsecure');
                $config['mailer_username']   = request('mailer_username');
                $config['mailer_password']   = request('mailer_password');
                $config['mailer_hostname']   = request('mailer_hostname');
                $config['mailer_from']       = request('mailer_from');
                $config['mailer_fromname']   = request('mailer_fromname');

                $test_message = "Тестовое сообщение с сайта " . $config['site_url'] . " отправлено успешно!";

                $answer = SendMail($uset['users_email'], $log, $test_message, $test_message, $config['mailer_from'], $config['mailer_fromname']);

                if ( $answer != 'ok' ) {

                    $inSes->addMessage('Произошла Ошибка! ' . $answer);

                }
                else {

                    foreach($_POST as $key => $val) {

                        $cfg[$key] = $val;
                    }

                    ini::save( CFG_FILE, $cfg );

                    $inSes->addMessage('Настройки отправки почты успешно изменены!', 'ok');

                    redirect('?m=set&' . RND);
                }
            }
            else {

                foreach($_POST as $key => $val) {

                    $cfg[$key] = $val;
                }

                ini::save( CFG_FILE, $cfg );

                $inSes->addMessage('Настройки отправки почты успешно изменены!', 'ok');

                redirect('?m=set&' . RND);
            }
        }
        else {

            $inSes->addMessage('Неверный идентификатор сессии, повторите действие!');
        }
    }

    show_header('Настройка отправки почтовых сообщений');

    $form = new cmsForm('?m=set_mail&amp;rnd=' . $_SESSION['token'], 'post');

    $form->addRadio('', 'mailer', $cfg['mailer'], array('mail' => 'MAIL - отправлять почту через функцию MAIL', 'smtp' => 'SMTP - отправлять почту через SMTP сервер'));
    $form->addText('SMTP сервер для отправки почты:', 'mailer_host', $cfg['mailer_host']);

    $form->addRadio('SMTP сервер требует авторизацию', 'mailer_smtpauth', $cfg['mailer_smtpauth'], array('true' => 'Если требуется авторизация - ДА', 'false' => 'в противном случае - НЕТ'));

    $form->addText('Имя пользователя на SMTP сервере:', 'mailer_username', $cfg['mailer_username']);

    $form->addPassword('Пароль пользователя на SMTP сервере:', 'mailer_password', $cfg['mailer_password']);

    $form->addText('Домен сайта на котором работает скрипт:', 'mailer_hostname', $cfg['mailer_hostname']);

    $form->addText(blink('*') . ' С какого ящика отправляем письмо:', 'mailer_from', $cfg['mailer_from']);

    $form->addText(blink('*') . ' От кого отправляем письмо:', 'mailer_fromname', $cfg['mailer_fromname']);

    $form->addText('Порт SMTP сервера (в варианте SMTP):', 'mailer_port', $cfg['mailer_port']);

    $form->addRadio('Варианты безопасного соединения SMTP сервера', 'mailer_smtpsecure', $cfg['mailer_smtpsecure'], array('' => 'Не безопасное соединение', 'ssl' => 'SSL', 'tls' => 'TLS'));

    $form->addCheckBox(array('', ' Проверить настройки почты<br />(вам будет отправлено тестовое письмо)'), 'check_mail_config', 1, array('1' => 'ДА', '0' => 'НЕТ'));
    echo $form->Submit('Изменить', 'submit');
    unset($form);

    echo '<div class="link"><a href="?m=set&amp;' . RND . '">Настройки</a></div>';
    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

}
else {

    redirect('/?' . RND);
}

?>