<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101))) {

    if (!defined('CFG_FILE')) define( 'CFG_FILE', ENGINE . '/data/config.ini' );

    $cfg = ini::read( CFG_FILE );

    if (!empty($_POST['submit'])) {

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            unset($_POST['submit']);

            $_POST['allow_rss'] = !empty($_POST['allow_rss']) ? 1 : 0;

            foreach($_POST as $key => $val) {

                $cfg[$key] = $val;
            }

            ini::save( CFG_FILE, $cfg );

            $inSes->addMessage('Прочие настройки успешно изменены!', 'ok');

            redirect('?m=set&' . RND);
        }
        else {

            $inSes->addMessage('Неверный идентификатор сессии, повторите действие!');
        }
    }

    show_header('Прочие настройки');

    $form = new cmsForm('?m=set_other&amp;rnd=' . $_SESSION['token'], 'post');
    $form->addCode('<b>Комментарии:</b><br />');
    $form->addText('Комментариев на стр.:', 'comm_num', $cfg['comm_num'], ' size="5"');
    $form->addText('Сколько давать монет (мин 0.01):', 'comm_add_money', $cfg['comm_add_money'], ' size="5"');
    $form->addText('На сколько увеличить авторитет:', 'comm_add_point', $cfg['comm_add_point'], ' size="5"');
    $form->addCode('<br /><b>RSS:</b><br />');
    $form->addText('Название ленты:', 'rss_title', $cfg['rss_title']);
    $form->addText('Новостей в ленте:', 'rss_num', num($cfg['rss_num']));
    $form->addCheckBox(array('', ' RSS (вкл/выкл)'), 'allow_rss', $cfg['allow_rss']);

    $form->addCode('<br /><b>Названия:</b><br />');
    $form->addText('Общее название денег, через запятую:', 'money_name', $cfg['money_name'], ' style="width:100%"');
    $form->addCode('<b>По примеру:</b><br />100 - монет<br />23 - монеты<br />1 - монета<br />');
    $form->addText('Неавторизованный пользователь:', 'guest_name', $cfg['guest_name']);
    $form->addText('Название рейтинга пользователей:', 'score_name', $cfg['score_name'], ' style="width:100%"');
    $form->addText('Название статусов:', 'status_name', $cfg['status_name'], ' style="width:100%"');
    echo $form->Submit('Изменить', 'submit');
    unset($form);

    echo '<div class="link"><a href="?m=set&amp;' . RND . '">Настройки</a></div>';
    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

}
else {

    redirect('/?' . RND);
}

?>