<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101))) {

    if (!defined('CFG_FILE')) define( 'CFG_FILE', ENGINE . '/data/config.ini' );

    $cfg = ini::read( CFG_FILE );

    if (!empty($_POST['submit'])) {

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            unset($_POST['submit']);

            foreach($_POST as $key => $val) {

                $cfg[$key] = $val;
            }

            ini::save( CFG_FILE, $cfg );

            $inSes->addMessage('Настройки успешно изменены!', 'ok');

            redirect('?m=set&' . RND);
        }
        else {

            $inSes->addMessage('Неверный идентификатор сессии, повторите действие!');
        }
    }

    show_header('Настройки цен');

    $form = new cmsForm('?m=set_shop&amp;rnd=' . $_SESSION['token'], 'post');

    $form->addCode('<b>Аватары - Лого:</b><br />');
    $form->addText('Стоймость покупки аватара:', 'avatar_pay', $cfg['avatar_pay'], ' size="5"');
    $form->addText('Стоймость загрузки аватара:', 'avatar_upload', $cfg['avatar_upload'], ' size="5"');
    $form->addText('Ширина и высота аватара:', 'avatar_size', $cfg['avatar_size'], ' size="5"');
    $form->addText('Макс. вес аватара:', 'avatar_weight', $cfg['avatar_weight'], ' size="5"');

    $form->addCode('<br /><b>Никнейм:</b><br />');
    $form->addText('Стоймость смены ника:', 'edit_nick_money', $cfg['edit_nick_money']);
    $form->addText('Стоймость смены цвета ника:', 'edit_color_money', $cfg['edit_color_money']);

    $form->addCode('<br /><b>Повышение рейтинга:</b><br />');
    $form->addText('На сколько повышать:', 'add_score_one', $cfg['add_score_one']);
    $form->addText('Стоймость повышения:', 'add_score_money', $cfg['add_score_money']);

    $form->addCode('<br /><b>Ограничения:</b><br />');
    $form->addText('Кол-во баллов для смены e-mail:', 'edit_mail_point', $cfg['edit_mail_point']);
    //$form->addText('Кол-во баллов для смены ника:', 'edit_nick_point', $cfg['edit_nick_point']);
    //$form->addText('Кол-во баллов для перевода денег:', 'edit_money_point', $cfg['edit_money_point']);
    $form->addText('Кол-во баллов для изменения авторитета:', 'edit_rating_point', $cfg['edit_rating_point']);

    echo $form->Submit('Изменить', 'submit');
    unset($form);

    echo '<div class="link"><a href="?m=set&amp;' . RND . '">Настройки</a></div>';
    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';
}
else {

    redirect('/?' . RND);
}

?>