<?php

if (!defined('CMS')) { die('Access Denied!'); }

# Фиксирование времени начала выполнения скрипта
$mts = microtime(1);

if (!defined('ROOT')) {

    $level  = 0;
    $folder = '';
    while ( !file_exists($folder . 'robots.txt') && $level < 5 ) {

        $folder .= '../'; 
        ++$level;
    }
    define('ROOT', $folder);
    unset($level, $folder);
}

define( 'DS', '/' );

define( 'VERSION', 'html' );

define( 'ENGINE', str_replace( "\\", "/", dirname(__FILE__) ) );

define( 'ROOTPATH', str_replace( "\\", "/", $_SERVER['DOCUMENT_ROOT'] ) );

define( 'CACHE_PATH', ENGINE . '/cache/' );

define( 'MODULES_PATH', ENGINE . '/modules/' );

define( 'TEMPLATES_PATH', ENGINE . '/templates/' );

define( 'THEMES_PATH', ROOTPATH . '/themes/' );

define( 'IMAGES_PATH', ROOTPATH . '/images/' );

define( 'IMAGES', '/images/' );

define( 'RND', mt_rand(1111, 9999) );

/* Настройки сайта */
if (!class_exists('ini')) {

    require( ENGINE . '/classes/ini.class.php' );
}

if (!file_exists( ENGINE . '/data/config.ini' )) {

    header('Location: /install.php'); die;
}

$config = ini::read( ENGINE . '/data/config.ini' );

$config['timeclocks'] = !empty($config['timeclocks']) ? $config['timeclocks'] : 0;

define( 'ADMIN_DIR', DS . $config['admin_dir'] . DS );       // Папка администратора
define( 'SITE_TIME', time() + $config['timeclocks'] * 3600); // Установка временного сдвига сайта
define( 'SP', 'cms' );                                       // Session prefix
define( 'CP', 'cms' );                                       // Cookies prefix

if (!empty($config['debug_mode'])) {

    error_reporting(E_ALL);
    ini_set('display_errors', true);
    ini_set('html_errors', true);
    ini_set('error_reporting', E_ALL);
}
else
{
    @error_reporting(0);
    @ini_set('display_errors', false);
    @ini_set('html_errors', false);
    @ini_set('error_reporting', E_ALL ^ E_NOTICE);
}

    error_reporting(E_ALL);
    ini_set('display_errors', true);
    ini_set('html_errors', true);
    ini_set('error_reporting', E_ALL);

ini_set('register_globals', 0);
ini_set('url_rewriter.tags', '');
ini_set('session.use_cookies', 1);
ini_set('session.use_trans_sid', 1);
ini_set('date.timezone', 'Europe/Moscow');
mb_internal_encoding('UTF-8');
session_name('sid') or die('Невозможно инициализировать сессии!');
session_start() or die('Невозможно инициализировать сессии!');

/* Подключили настройки БД и функции */
require( ENGINE . '/DbSimple//Generic.php' );
require( ENGINE . '/data/dbconfig.php' );
require( ENGINE . '/functions.php' );
require( ENGINE . '/classes/session.class.php' );

$inSes = cmsSession::getInstance();

//$err = error_get_last();
//print_r($err);

$arr_themes = array('wap','web','touch');

# Локализация для даты
$lang['months'] = array (
'01'        => 'Января',
'02'        => 'Февраля',
'03'        => 'Марта',
'04'        => 'Апреля',
'05'        => 'Мая',
'06'        => 'Июня',
'07'        => 'Июля',
'08'        => 'Августа',
'09'        => 'Сентября',
'10'        => 'Октября',
'11'        => 'Ноября',
'12'        => 'Декабря',
);

$lang['date'] = array (
'01'        => 'Январь',
'02'        => 'Февраль',
'03'        => 'Март',
'04'        => 'Апрель',
'05'        => 'Май',
'06'        => 'Июнь',
'07'        => 'Июль',
'08'        => 'Август',
'09'        => 'Сентябрь',
'10'        => 'Октябрь',
'11'        => 'Ноябрь',
'12'        => 'Декабрь',
'January'   => 'января',
'February'  => 'февраля',
'March'     => 'марта',
'April'     => 'апреля',
'May'       => 'мая',
'June'      => 'июня',
'July'      => 'июля',
'August'    => 'августа',
'September' => 'сентября',
'October'   => 'октября',
'November'  => 'ноября',
'December'  => 'декабря',
'Jan'       => 'янв',
'Feb'       => 'фев',
'Mar'       => 'мар',
'Apr'       => 'апр',
'Jun'       => 'июн',
'Jul'       => 'июл',
'Aug'       => 'авг',
'Sep'       => 'сен',
'Oct'       => 'окт',
'Nov'       => 'ноя',
'Dec'       => 'дек',

'Sunday'    => 'Воскресенье',
'Monday'    => 'Понедельник',
'Tuesday'   => 'Вторник',
'Wednesday' => 'Среда',
'Thursday'  => 'Четверг',
'Friday'    => 'Пятница',
'Saturday'  => 'Суббота',
'Sun'       => 'Вс',
'Mon'       => 'Пн',
'Tue'       => 'Вт',
'Wed'       => 'Ср',
'Thu'       => 'Чт',
'Fri'       => 'Пт',
'Sat'       => 'Сб',
);

# Для архива и календаря
$lang['date_f']  = array('января', 'февраля', 'марта', 'апреля', 'мая', 'июня', 'июля', 'августа', 'сентября', 'октября', 'ноября', 'декабря');
$lang['date_r']  = array('Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь', 'Июль', 'Август', 'Сентябрь', 'Октябрь', 'Ноябрь', 'Декабрь');
$lang['date_short_week_days'] = array('Вс','Пн','Вт','Ср','Чт','Пт','Сб');

$lang['OR']          = 'или';
$lang['AND']         = 'и';
$lang['SEARCH_WORD'] = '«%s»';

# Установка переменных
$ip = get_ip();

if (isset($_SERVER['PHP_SELF'])) {

    $php_self = check(substr($_SERVER['PHP_SELF'], 1));
}
if (isset($_SERVER['REQUEST_URI'])) {

    $request_uri = check(urldecode(substr(strtok($_SERVER['REQUEST_URI'], 'S'), 1)));
    $request_uri = !empty($request_uri) ? $request_uri : check(substr($_SERVER['PHP_SELF'], 1));
}
if (isset($_SERVER['HTTP_REFERER'])) {

    $http_referer = check(urldecode(strtok($_SERVER['HTTP_REFERER'], 'S')));
}
else $http_referer = 'Не определено';

if (empty($_SESSION[SP]['log'])) {

    $username = !empty($config['guest_name']) ? $config['guest_name'] : 'Гость';
}
else $username = $_SESSION[SP]['log'];

if (empty($_SESSION[SP]['brow'])) {

    $brow = get_ua();
}
else $brow = $_SESSION[SP]['brow'];

$_SESSION[SP]['brow'] = $brow;

if (empty($_SESSION['counton'])) {

    $_SESSION['counton'] = 0;
}

if (empty($_SESSION['currs'])) {

    $_SESSION['currs'] = SITE_TIME;
}

if (empty($_SESSION['token'])) {

    $_SESSION['token'] = random_string(6);
}

$_SESSION['timeon'] = maketime(SITE_TIME - $_SESSION['currs']);

$log       = '';
$is_admin  = FALSE;
$is_logged = FALSE;
$swfobject = FALSE;
$js_vars   = array();
$uset      = array();

?>