<?php

if (!defined('CMS')) { die('Access Denied!'); }

$onlines = array(
     '0' => 'Все',
     '1' => 'Обитатели',
     '2' => 'Гости',
);

$onpage = !empty($config['onpage']) ? num($config['onpage']) : 10;

if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

if (!empty($id) && $id == 1) {

    $rows = $db->selectPage($total, "SELECT * FROM ?_users_online
                                     WHERE `online_user` != ''
                                     ORDER BY `online_time` DESC 
                                     LIMIT ?d, ?d", $from, $onpage);

   show_header('Кто в онлайне - Обитатели сайта');
   $show_total = 'Всего обитателей: ' . $total;
   $show_error = 'Обитателей на сайте пока нет!';

}
else if (!empty($id) && $id == 2) {

    $rows = $db->selectPage($total, "SELECT * FROM ?_users_online
                                     WHERE `online_user` = ''
                                     ORDER BY `online_time` DESC 
                                     LIMIT ?d, ?d", $from, $onpage);

   show_header('Кто в онлайне - Гости сайта');
   $show_total = 'Всего гостей: ' . $total;
   $show_error = 'Гостей на сайте пока нет!';
}
else {

    $rows = $db->selectPage($total, "SELECT * FROM ?_users_online
                                     ORDER BY `online_time` DESC 
                                     LIMIT ?d, ?d", $from, $onpage);

   show_header('Кто в онлайне');
   $show_total = 'Всего пользователей: ' . $total;
   $show_error = 'Пользователей на сайте пока нет!';
}

$show = array();
foreach($onlines as $key => $val) {

    if ($key == $id) $show[] = '<td style="width:33%"><span>' . $val . '</span></td>';
    else $show[] = '<td style="width:33%"><a href="' . gen_uri('online', $key, RND) . '">' . $val . '</a></td>';
}

echo '<div class="blocks"><table><tr>' . implode('', $show) . '</tr></table></div>';

if (!empty($rows) && $total > 0) {

    $i = $from + 1;

    foreach ($rows as $numRow => $row) {

        $user = !empty($row['online_uid']) ? users_anketa($row['online_uid'], $row['online_user']) : '<b>Гость</b>';

        echo '<div class="bl">';
        echo '<div class="fr">' . get_date($row['online_time'], 'H:i') . '</div>';
        echo $i++ . '. ' . icon('user.png') . $user;
        echo '<br />Сейчас: <a href="' . $config['site_url'] . $row['online_path'] . '">' . $row['online_title'] . '</a>';
        echo '<br /><span class="data">(' . $row['online_ip'] . ', ' . $row['online_brow'] . ')</span><br />';
        echo '</div>';
    }

    echo show_pages('online', $id, 'p');

    echo '<div class="bl">' . $show_total . '<br /></div>';
}
else {

    show_error($show_error);
}

?>