<?php

if (!defined('CMS')) { die('Access Denied!'); }

# Кеширование стран
$countries = get_vars('country');

if (!$countries || !is_array($countries)) {

    $countries = array();
    $rows = $db->select("SELECT `tld`,`name` FROM ?_country ORDER BY `name` ASC;");
    foreach($rows as $row) $countries[$row['tld']] = $row['name'];
    set_vars('country', $countries);
}

$onpage = !empty($config['user_list']) ? num($config['user_list']) : 10;

if (!empty($_GET['user']) || !empty($_POST['user'])) {

    $uz = !empty($_GET['user']) ? check($_GET['user']) : check($_POST['user']);

    $is_user = $db->selectRow("SELECT `users_id` FROM ?_users WHERE `users_login` = ? LIMIT 1;", $uz);

    if (!empty($is_user)) {

        $ratusers = $db->select("SELECT `users_login` FROM ?_users ORDER BY `users_point` DESC, `users_login` ASC;");

        foreach($ratusers as $key => $val) {

            if ($uz == $val['users_login']) {

                $rat = $key + 1;
                break;
            }
        }

        if (!empty($rat)) {

            $inSes->addMessage('Позиция в рейтинге: <b>' . ($rat) . '</b>', 'info');

            $end = ceil( $rat / $onpage ); 

            if ($end < 1) $end = 1;

            if ($end != $page) {

                gen_red($mod, 'p' . $end, 'user=' . $uz . '&' . UID);
            }
        }
        else {

            $inSes->addMessage('Пользователь с данным логином не найден!', 'warning');
        }
    }
    else {

        $inSes->addMessage('Пользователь с данным логином не зарегистрирован!', 'warning');
    }
}
else $uz = '';

    show_header('Список пользователей');

    if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

    $rows = $db->selectPage($total, "SELECT `u`.*, `v`.`visit_nowtime`
                                     FROM ?_users `u` LEFT JOIN ?_users_visit `v`
                                     ON `u`.`users_login` = `v`.`visit_user`
                                     ORDER BY `u`.`users_point` DESC, `u`.`users_login` ASC 
                                     LIMIT ?d, ?d", $from, $onpage);

    if (!empty($rows) && $total > 0) {

        $i = $from + 1;
        foreach($rows as $row) {

            echo '<div class="bl"> ';
            echo $i++ .  '. ' . user_visit_icon($row['users_login'], $row['users_gender'], $row['visit_nowtime']) . ' ';

            if (!empty($_REQUEST['user']) && $_REQUEST['user'] == $row['users_login']) {

                echo '<b>' . users_anketa($row['users_login'], '#ff0000') . '</b>';
            }
            else {

                echo users_anketa($row['users_login']);
            }

            echo ' (' . num2name($row['users_point'], $config['score_name']) . ')<br />';

            if (!empty($row['users_country']) && !empty($row['users_city'])) {

                echo '<a href="' . gen_uri('country', '', 'c=' . $row['users_country'] . '&amp;' . RND) . '">' . $countries[$row['users_country']] . '</a>';
                echo ' | <a href="' . gen_uri('city', '', 'c=' . $row['users_city'] . '&amp;' . RND) . '">' . $row['users_city'] . '</a><br />';
            }
            else if (!empty($row['users_country'])) {

                echo '<a href="' . gen_uri('country', '', 'c=' . $row['users_country'] . '&amp;' . RND) . '">' . $countries[$row['users_country']] . '</a><br />';
            }
            else if (!empty($row['users_city'])) {

                echo '<a href="' . gen_uri('city', '', 'c=' . $row['users_city'] . '&amp;' . RND) . '">' . $row['users_city'] . '</a><br />';
            }
            echo 'Посещений: ' . $row['users_visits'] . '<br />';
            echo 'Дата регистрации: ' . get_date($row['users_joined'], 'j F Y') . '</div>';
        }

        echo show_pages('userlist', '', 'p');

        $form = new cmsForm(gen_uri('userlist', '', 'page=' . $page));
        $form->addText('<b>Поиск по нику:</b>', 'user', request('user',$log));
        echo $form->Submit('Искать');
        unset($form);
        echo '<div class="bl">Всего пользователей: <b>' . $total . '</b><br /></div>';
    }
    else {

        show_error('Пользователей ещё нет!');
    }

?>
