<?php

if (!defined('CMS')) { die('Access Denied!'); }

$data = array();
$data = $db->selectRow("SELECT * FROM ?_users WHERE `users_id` = ? LIMIT 1;", $user_id);

if (empty($data) || !is_array($data)) {

    $inSes->addMessage('Ошибка! Пользователь с данным логином не найден!');
    redirect($config['site_url']);
}

if ($data['users_ban'] == 1) {

    $inSes->addMessage('Ошибка! Пользователь заблокирован!');
    redirect($config['site_url']);
}

if ($config['allow_regkeys'] > 0 && $data['users_confirmreg'] > 0) {

    $inSes->addMessage('Ошибка! Пользователя не существует!');
    redirect($config['site_url']);
}

$title = ($is_logged && $data['users_login'] == $log) ? 'Мои блоги' : 'Блоги пользователя ' . nickname($data['users_login']);

show_header($title);

$onpage = !empty($config['blog_num']) ? num($config['blog_num']) : 10;

if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

$rows = array();
$rows = $db->selectPage($total, "SELECT * FROM ?_blog_posts
                                 WHERE `blog_moders` <> '1' AND `blog_user` = ?
                                 ORDER BY `blog_time` DESC 
                                 LIMIT ?d, ?d", $data['users_login'], $from, $onpage );

if (!empty($rows) && $total > 0) {

    $c = $from + 1;

    foreach ($rows as $numRow => $row) {

        echo '<a class="links" href="' . $config['site_url'] . '/blog/' . gen_uri('post', $row['blog_id'], RND) . '">'; 
        echo icon('list.png') . $row['blog_title'] . '<br />';
        echo '<span class="text">' . format_text($row['blog_text']) . '...<br />';
        echo ' Комментарии: <b>' . num($row['blog_comments']);
        echo '</b></span></a>';
    }

    echo show_pages('blogs', '', 'p');
}
else {

    show_error('Статей еще нет, будь первым!');
}

echo '<div class="blocks"><table><tr>';
echo '<td class="w25"><a href="' . $config['site_url'] . '/blog/' . gen_uri('index', '', RND) . '">Блоги</a></td>';
echo '<td class="w25"><a href="' . $config['site_url'] . '/blog/' . gen_uri('search', '', RND) . '">Поиск</a></td>';
echo '<td class="w25"><a href="' . $config['site_url'] . '/blog/' . gen_uri('category', '', RND) . '">Категории</a></td>';
echo '<td class="w25"><a href="' . $config['site_url'] . '/blog/' . gen_uri('add', '', RND) . '">Написать</a></td></tr></table></div>';

?>