<?php

if (!defined('CMS')) { die('Access Denied!'); }

$row = $db->selectRow( "SELECT * FROM ?_pages WHERE `name` = ? AND `active` = '1' LIMIT 1", 'users_' . $mod );

if (!empty($row)) {

    show_header($row['title'], $row['keys'], $row['desc']);

    $row['text'] = html_entity_decode($row['text'], ENT_QUOTES, 'UTF-8');

    if ($row['allow_br'] == 1) echo '<div class="bl">' . nl2br(bb_code(smiles($row['text']))) . '</div>';
    else echo '<div class="bl">' . bb_code(smiles($row['text'])) . '</div>';

    if (!is_admin()) {

        if ( empty($_SESSION[SP]['views'][$row['id']]) ) {

            $db->query( "UPDATE ?_pages SET `views` = (`views` + 1) WHERE `id` = ? LIMIT 1", $row['id'] );
        }

        $_SESSION[SP]['views'][$row['id']] = 1;
    }

    echo '<div class="bl">' . icon('return.png') . '<a href="' . gen_uri('index', $id, RND) . '">Назад</a></div>';
}
else {

    $inSes->addMessage('Ошибка 404! Страница не найдена или ссылка не верна!');
    gen_red('index', '', RND);
}

?>
