<?php
define('CMS',TRUE);

define('ROOT','../');

define('EMPTY_ADS',TRUE); // Отключили рекламу в админке

define('IS_ADMINKA',TRUE); // Отключили запись онлайн в админке

require('../core/inc.php');

if (!$is_logged) {

    redirect($config['site_url']);
}

if (!empty($config['admin_auth'])) {

    $cur_date = date('d');

    if (!empty($_POST['pswd']) && $_POST['pswd'] == $config['admin_auth']) {

        $_SESSION[SP]['admin'][$cur_date] = md5($config['admin_auth']);

    }
    else if (empty($_SESSION[SP]['admin'][$cur_date]) || md5($config['admin_auth']) <> $_SESSION[SP]['admin'][$cur_date]) {

        show_header('');
        $form = new cmsForm();
        $form->addCode(blink('Внимание!') . ' Доступ только по паролю<br />');
        $form->addText('Ваш пароль:','pswd');
        echo $form->Submit('ОК');
        show_footer();
        exit();
    }
}

if (is_admin()) {

    $id = !empty($_GET['id']) ? (int) $_GET['id'] : 0;
    $mod = !empty($_GET['m']) ? (string) $_GET['m'] : '';
    $page = !empty($_GET['page']) ? (int) $_GET['page'] : 1;
    $onpage = 10;

    switch($mod):

        case 'ban': case 'ban_user': case 'edit_ban': case 'ban_history':
            include(ENGINE.'/admin/ban.php');
        break;

        case 'blog': case 'blogs': case 'blog_edit_cat': case 'blog_del_cat': case 'blog_edit': case 'blog_move': case 'moders':
            include(ENGINE.'/admin/blog.php');
        break;

        case 'board': case 'boards': case 'board_edit_cat': case 'board_del_cat': case 'board_edit': case 'board_move': case 'board_moders':
            include(ENGINE.'/admin/board.php');
        break;

        case 'chat': case 'reply_chat': case 'quote_chat': case 'clear_chat':
            include(ENGINE.'/admin/chat.php');
        break;

        case 'journal': case 'journals': case 'journal_edit_cat': case 'journal_del_cat': case 'journal_edit': case 'journal_move': case 'moders_journal':
            include(ENGINE.'/admin/journal.php');
        break;

        case 'load': case 'cats': case 'downs': case 'del_cats':
        case 'new_file': case 'edit_file': case 'del_file': case 'del_files': case 'move_files':
            include(ENGINE.'/admin/loads.php');
        break;
        case 'down_upload':
            include(ENGINE.'/admin/down_upload.php');
        break;

        case 'forum': case 'edit_forum': case 'del_forum': case 'forums': 
        case 'edit_topic': case 'move_topic': case 'act_topic': case 'topic': case 'edit_post':
            include(ENGINE.'/admin/forum.php');
        break;

        case 'present': case 'add_present': case 'edit_present':
            include(ENGINE.'/admin/present.php');
        break;

        case 'news': case 'add_news': case 'edit_news':
            include(ENGINE.'/admin/news.php');
        break;

        case 'guest': case 'reply_guest': case 'edit_guest': case 'clear_guest':
            include(ENGINE.'/admin/guest.php');
        break;

        case 'gallery': case 'edit_photos':
            include(ENGINE.'/admin/gallery.php');
        break;

        case 'users': case 'users_edit': case 'users_del':
            include(ENGINE.'/admin/users.php');
        break;

        default:

        if ( @file_exists( ENGINE . '/admin/' . $mod . '.php' )) {

            include( ENGINE . '/admin/' . $mod . '.php' );
        }
        else {

            if (is_admin(array(101))) {

                if (!empty($_GET['clear_cache'])) {

                    deldir( ENGINE . '/cache' );

                    $inSes->addMessage('Кеш успешно очишен!', 'ok');

                    redirect('?' . RND);
                }
            }

//$stat = get_vars('stats_admin', 900);

//if (!$stat || !is_array($stat)) {

    $days = (SITE_TIME-86400 * 3);
    $stat = array();
    $stat = $db->selectRow("SELECT COUNT(1) AS `chat`,
                           (SELECT COUNT(1) FROM ?_ads) AS `ads`,
                           (SELECT COUNT(1) FROM ?_users WHERE `users_level` >= 101 AND `users_level` <= 105) AS `admins`,
                           (SELECT COUNT(1) FROM ?_comments) AS `comm`,
                           (SELECT COUNT(1) FROM ?_users WHERE `users_ban` = 1 AND `users_timeban` > ?) AS `ban`,
                           (SELECT COUNT(1) FROM ?_blog_posts) AS `all_blog`,
                           (SELECT COUNT(1) FROM ?_blog_posts WHERE `blog_time` > ?) AS `new_blog`,
                           (SELECT COUNT(1) FROM ?_blog_posts WHERE `blog_moders` = 1) AS `moder_blog`,
                           (SELECT COUNT(1) FROM ?_users WHERE `users_confirmreg` > 0) AS `reglist`,
                           (SELECT COUNT(1) FROM ?_users) AS `all_users`,
                           (SELECT COUNT(*) FROM ?_users WHERE `users_joined` > UNIX_TIMESTAMP(CURDATE())) AS `new_users`
                           FROM ?_chat;", SITE_TIME, $days, $days, $days, (SITE_TIME-86400 * 5));

    $stat            = array_map('intval', $stat);
    $stat['blog']    = !empty($stat['new_blog']) ? num($stat['all_blog']) . '/+' . num($stat['new_blog']) : num($stat['all_blog']);
    $stat['users']   = !empty($stat['new_users']) ? num($stat['all_users']) . '/+' . num($stat['new_users']) : num($stat['all_users']);

    //set_vars('stats_admin', $stat);
//}

            show_header('Панель управления');

            echo '<div class="bl"><b>Модератор</b><br />';
            echo '- <a href="?m=chat">Админ-чат</a> (' . $stat['chat'] . ')<br />';
            echo '- <a href="?m=blog">Управление блогами</a> (' . $stat['blog'] . ')<br />';

            if (is_admin(array(101, 102, 103))) {

                echo '</div><div class="bl"><b>Старший модер</b><br />';
                echo '- <a href="?m=ban">Список забаненых</a> (' . $stat['ban'] . ')<br />';
                echo '- <a href="?m=adminlist">Список старших</a> (' . $stat['admins'] . ')<br />';
                echo '- <a href="?m=reglist">Список ожидающих</a> (' . $stat['reglist'] . ')<br />';
                echo '- <a href="?m=comments">Управление ком-ми</a> (' . $stat['comm'] . ')<br />';
            }

            if (is_admin(array(101, 102))) {

                echo '</div><div class="bl"><b>Администратор</b><br />';
                echo '- <a href="?m=ads">Реклама</a> (' . $stat['ads'] . ')<br />';
                echo '- <a href="?m=users">Пользователи</a> (' . $stat['users'] . ')<br />';
                echo '- <a href="?m=phpinfo">PHP-информация</a> (' . phpversion() . ')<br />';
                echo '- <a href="?m=status">Управление статусами</a><br />';
                echo '- <a href="?m=mat">Управление матом</a><br />';
                echo '- <a href="?m=set">Настройки сайта</a><br />';
                echo '- <a href="?clear_cache=1">Очистка кэша</a><br />';
                echo '- <a href="?m=static">Статические страницы</a><br />';

                if ($log == $config['nickname']) {

                    echo '- <a href="?m=backup">Архивация и восстановление</a><br />';
                }
            }

            echo '</div>';

            $row = $db->selectRow("SELECT `users_level` FROM ?_users WHERE `users_login` = ? LIMIT 1;", $config['nickname']);

            if (!empty($row)) {

              if ($row['users_level'] <> 101) {

                ?>
                <div class="message_info"><b><span style="color:#ff0000">Внимание!!! Cуперадминистратор не имеет достаточных прав!</span></b><br />
                Профилю назначен уровень доступа <b><?=$row['users_level']?> - <?=user_status($row['users_level'])?></b></div>
                <?php
              }
            }
            else {

              ?>
              <div class="message_info"><b><span style="color:#ff0000">Внимание!!! Отсутствует профиль суперадмина</span></b><br />
              Профиль администратора <b><?=$config['nickname']?></b> не задействован на сайте</div>
              <?php
            }

            if ( @file_exists($_SERVER['DOCUMENT_ROOT'] . '/install.php') && !empty($config['nickname'])) {

              ?>
              <div class="message_info"><b><span style="color:#ff0000">Внимание!!! Необходимо удалить файл install.php</span></b><br />
              Наличие этого файла может нарушить безопасность сайта. Удалите его прямо сейчас!</div>
              <?php

            }
        }

    break;
    endswitch;

    show_footer();
}
else {

    redirect($config['site_url']);
}

?>
