<?php
define('CMS',TRUE);
define('ROOT','../');
require('../core/inc.php');

$id = !empty($_GET['id']) ? (int) $_GET['id'] : 0;
$mod = !empty($_GET['m']) ? (string) $_GET['m'] : '';
$page = !empty($_GET['page']) ? (int) $_GET['page'] : 1;
$onpage = !empty($config['blog_num']) ? num($config['blog_num']) : 10;
$is_admin = (bool) is_admin() ? true : false;

if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

# Кеширование категорий блога
$categories = get_vars('blog_categories');

if (!$categories) {

    $db->query("UPDATE ?_blog_category SET `cats_count` = (SELECT COUNT(`blog_id`) FROM ?_blog_posts 
                WHERE ?_blog_category.`cats_id` = ?_blog_posts.`blog_cats_id`);");

    $categories = array();

    $cats = $db->select("SELECT * FROM ?_blog_category ORDER BY `cats_order` ASC;");

    if (!empty($cats) && count($cats) > 0) {

        foreach( $cats as $cat ) {

            $categories[$cat['cats_id']] = array($cat['cats_name'], $cat['cats_text'], $cat['cats_count']);
        }

        set_vars('blog_categories',$categories);
    }
}

if (!empty($mod) && @file_exists( MODULES_PATH . 'blog_' . $mod . '.php' )) {

    include( MODULES_PATH . 'blog_' . $mod . '.php' );
}
else {

    if (!empty($mod) && $mod == 'top') {

        $rows = $db->selectPage($total, "SELECT * FROM ?_blog_posts
                                         WHERE `blog_moders` <> '1'
                                         ORDER BY `blog_comments` DESC 
                                         LIMIT ?d, ?d", $from, $onpage );

        show_header('Блоги - Популярное');

        echo '<div class="blocks"><table><tr>';
        echo '<td class="w25"><a href="' . gen_uri('new', '', RND) . '">Новое</a></td>';
        echo '<td class="w25"><span class="b">Популярное</span></td>';
        echo '<td class="w25"><a href="' . gen_uri('category', '', RND) . '">Категории</a></td>';
        echo '<td class="w25"><a href="' . gen_uri('add', '', RND) . '">Написать</a></td></tr></table></div>';
    }
    else {

        $rows = $db->selectPage($total, "SELECT * FROM ?_blog_posts
                                         WHERE `blog_moders` <> '1'
                                         ORDER BY `blog_time` DESC 
                                         LIMIT ?d, ?d", $from, $onpage );


        show_header('Блоги');

        echo '<div class="blocks"><table><tr>';
        echo '<td class="w25"><span class="b">Новое</span></td>';
        echo '<td class="w25"><a href="' . gen_uri('top', '', RND) . '">Популярное</a></td>';
        echo '<td class="w25"><a href="' . gen_uri('category', '', RND) . '">Категории</a></td>';
        echo '<td class="w25"><a href="' . gen_uri('add', '', RND) . '">Написать</a></td></tr></table></div>';
    }

    if (is_admin()) {

       echo '<div class="link"><a href="' . gen_admin('?m=blog&amp;' . RND) . '">Управление</a></div>';
    }

    if (!empty($rows) && $total > 0) {

        foreach($rows as $numRow => $row) {

            if (!empty($row['blog_is_xxx'])) {

                $xxx = ' <span style="color:#ff0000">(18+)</span>';
            }
            else $xxx = '';

            echo '<a class="links" href="' . $config['site_url'] . '/blog/' . gen_uri('post', $row['blog_id'], RND) . '">'; 
            echo icon('list.png') . $row['blog_title'] . '<br />';
            echo '<span class="text">' . format_text($row['blog_text']) . '...<br />';
            echo ' Комментарии: <b>' . num($row['blog_comments']);
            echo '</b></span></a>';
        }

        echo show_pages($mod, '', 'p');

    }
    else {

        show_error('Статей еще нет, будь первым!');
    }

    echo '<div class="blocks"><table><tr>';
    echo '<td class="w25"><a href="' . gen_uri('top', '', RND) . '">Топ статей</a></td>';
    echo '<td class="w25"><a href="' . gen_uri('search', '', RND) . '">Поиск</a></td>';
    echo '<td class="w25"><a href="' . gen_uri('category', '', RND) . '">Категории</a></td>';
    echo '<td class="w25"><a href="' . gen_uri('add', '', RND) . '">Написать</a></td></tr></table></div>';

}

show_footer();

?>