<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101, 102, 103))) {

    $arr_time = array('86400' => 'День', '604800' => 'Неделя', '2419200' => 'Месяц');

    if (!empty($_POST['add_ads'])) {

        $url = !empty($_POST['url'])   ? trim($_POST['url'])    : '';
        $nms = !empty($_POST['name'])  ? check($_POST['name'])  : '';
        $clr = !empty($_POST['color']) ? check($_POST['color']) : '';
        $cnt = !empty($_POST['count']) ? num($_POST['count'])   : 1;
        $tms = !empty($_POST['time'])  ? num($_POST['time'])    : '2419200';
        $bold = !empty($_POST['bold']) ? 1 : 0;

        $add_time = time()+($_POST['time']*$cnt);

        if (!empty($url) && !empty($nms)) {

            $db->query( "INSERT INTO ?_ads SET `ads_url` = ?, `ads_name` = ?, `ads_color` = ?, `ads_bold` = ?, `ads_time` = ?", $url, $nms, $clr, $bold, $add_time );

            $inSes->addMessage('Рекламная площадка успешно добавлена!', 'ok');
        }
        else $inSes->addMessage('Ошибка! Вы не ввели урл или название!');

    }
    else if (!empty($_REQUEST['del'])) {

        $del = intar($_REQUEST['del']);

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            if (is_array($del)) {

                $del = implode(',', $del);

                $db->query("DELETE FROM ?_ads WHERE `ads_id` IN (" . $del . ");");

                $inSes->addMessage('Выбранные площадки успешно удалены!', 'ok');
            }
            else {

                $db->query("DELETE FROM ?_ads WHERE `ads_id` = ? LIMIT 1;", $del);

                $inSes->addMessage('Рекламная площадка успешно удалена!', 'ok');
            }

            $db->query("OPTIMIZE TABLE ?_ads");

        }
        else $inSes->addMessage('Ошибка! Неверный идентификатор сессии, повторите действие!');

        redirect('?m=ads&' . RND);
    }
	
    show_header('Реклама на сайте');
    $form = new cmsForm('?m=ads&amp;rnd=' . $_SESSION['token']);
    $form->addText('Название площадки:', 'name', request('name'));
    $form->addText('Адрес площадки (без http://):', 'url', request('url'));
    $form->addCode('<input type="text" name="count" size="3" value="' . request('count',1) . '" /> ');
    $form->addSelect('', 'time', request('time'), $arr_time);
    $form->addText('Выделение цветом (max 7):', 'color', request('color'));
    $form->addCheckBox(array('',' - Жирный шрифт'), 'bold', request('bold'));
    echo $form->Submit('Добавить', 'add_ads');
    unset($form);

    $onpage = !empty($config['posts_num']) ? num($config['posts_num']) : 10;

    if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

    $rows = $db->selectPage( $total, "SELECT * FROM ?_ads ORDER BY `ads_id` DESC LIMIT ?d, ?d", $from, $onpage );

    if (!empty($rows) && $total > 0) {

        echo '<form action="?m=ads&amp;rnd=' . $_SESSION['token'] . '" method="post" name="ads">';

        foreach ($rows as $numRow => $row) {

            if (!empty($row['ads_color'])) $row['ads_name'] = '<span style="color:' . $row['ads_color'] . ';">' . $row['ads_name'] . '</span>';
            if (!empty($row['ads_bold'])) $row['ads_name'] = '<b>' . $row['ads_name'] . '</b>';

            $time = $row['ads_time']-time();
            $time = $time/86400;
            $time = round($time);
            echo '<div class="bl">Название: ' . $row['ads_name'] . '<br />';
            echo 'Адрес: <a href="http://' . $row['ads_url'] . '">http://' . $row['ads_url'] . '</a><br />';
            echo '<input type="checkbox" name="del[]" value="' . num($row['ads_id']) . '" /> ';
            echo 'Переходов: <b>' . intval($row['ads_count']) . '</b><br />';
            echo 'Осталось: <b>' . intval($time) . '</b>  дней<br /></div>';
        }

        echo show_pages('?m=ads&amp;' . RND);

        echo '<div class="bl">';
        echo '<input type="checkbox" name="master_box" title="Отметить всё" onclick="javascript:ckeck_uncheck_all()"> ';
        echo '<input type="submit" class="btns" value="Удалить выбранное" /></form></div>';
        echo <<<JSCRIPT

<script language='JavaScript' type="text/javascript">
<!--
function ckeck_uncheck_all() {
    var frm = document.ads;
    if(frm.master_box.checked == true){ frm.master_box.checked = false; }
    else{ frm.master_box.checked = true; }
    for (var i=0;i<frm.elements.length;i++) {
        var elmnt = frm.elements[i];
        if (elmnt.type=='checkbox') {
            if(frm.master_box.checked == true){ elmnt.checked=false; }
            else{ elmnt.checked=true; }
        }
    }
}
-->
</script>

JSCRIPT;

    }
    else show_error('Рекламных площадок пока нет!');

    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

    show_footer();
}
else {

    redirect('/?' . RND);
}

?>