<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101, 102, 103))) {

    if (!empty($_POST['submit'])) {

        $choice = !empty($_POST['choice']) ? num($_POST['choice']) : 0;
        $arrayusers = !empty($_POST['arrayusers']) ? check($_POST['arrayusers']) : '';

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

          if (!empty($choice)) {

            if (!empty($arrayusers)) {

              if ($choice == 1) { // Разрешение регистрации

                  $arrayusers = implode(',', $arrayusers);
                  $db->query("UPDATE ?_users SET `users_confirmreg` = '0', `users_confirmregkey` = '' 
                              WHERE `users_login` IN ('" . $arrayusers . "');");

                  $inSes->addMessage('Выбранные аккаунты успешно одобрены!', 'ok');
              }
              if ($choice == 2) { // Запрет регистрации

                  foreach($arrayusers as $value) {

                      delete_album($value);
                      delete_users($value);
                  }

                  $inSes->addMessage('Выбранные пользователи успешно удалены!', 'ok');
              }
            }
            else $inSes->addMessage('Ошибка! Отсутствуют выбранные пользователи!');
          }
          else $inSes->addMessage('Ошибка! Не выбрано действие для пользователей!');
        }
        else $inSes->addMessage('Ошибка! Неверный идентификатор сессии, повторите действие!');
    }

    show_header('Ожидающие регистрации');

    if ($config['allow_regkeys'] == 0) {

        show_error('Подтверждение регистрации отключено!');
    } 
    else if ($config['allow_regkeys'] == 1) {

        show_error('Включено автоматическое подтверждение регистраций!');
    } 
    else if ($config['allow_regkeys'] == 2) {

        show_error('Включена модерация регистраций!');
    }

    /* Удаление не подтвердивших регистрацию */
    if ($config['allow_regkeys'] == 1) {

        $arrdelusers = $db->select("SELECT `users_login` FROM ?_users
                                    WHERE `users_confirmreg` > ? AND `users_joined` < ?;", '0', SITE_TIME-86400);
        $deltotal = count($arrdelusers);

        if ($deltotal > 0) {

            $show = array();
            foreach($arrdelusers as $key => $value) {

                $show[] = '<b>' . $value . '</b>';
                delete_album($value);
                delete_users($value);
            }

            echo '<div class="bl">Автоматически удалено аккаунтов: <b>' . $deltotal . '</b><br />' . implode(', ', $show) . '<br /></div>';
        } 
    }

    $onpage = !empty($config['user_list']) ? num($config['user_list']) : 10;

    if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

    $rows = array();
    $rows = $db->selectPage( $total, "SELECT * FROM ?_users 
                                      WHERE `users_confirmreg` > 0 
                                      ORDER BY `users_joined` DESC 
                                      LIMIT ?d, ?d", $from, $onpage);

    if (!empty($rows) && $total > 0) {

        echo '<form action="?m=reglist&amp;rnd=' . $_SESSION['token'] . '" method="post" name="reglist">';

        foreach($rows as $data) {

            if (empty($data['users_email'])) {

                $data['users_email'] = 'Не указан';
            } 
            echo '<div class="bl">';
            echo '<input type="checkbox" name="arrayusers[]" value="' . $data['users_login'] . '" /> ';
            echo icon('user.png') . ' <b>' . users_anketa($data['users_login']) . '</b> ';
            echo '(E-mail: ' . $data['users_email'] . ')<br />';
            echo 'Зарегистрирован: ' . get_date($data['users_joined']) . '</div>';
        } 

        echo '<div class="bl">';
        echo '<input type="checkbox" name="master_box" title="Отметить всё" onclick="javascript:ckeck_uncheck_all()"> ';
        echo '<select name="choice">';
        echo '<option value="1">Разрешить</option>';
        echo '<option value="2">Запретить</option>';
        echo '</select> ';
        echo '<input type="submit" name="submit" class="btns" value="Выполнить" /></div></form>';

        echo show_pages('?m=reglist');

        echo '<div class="bl">Всего ожидающих: <b>'.(int)$total.'</b><br /></div>';
    }
    else {

        show_error('Нет пользователей требующих подтверждения регистрации!');
    }

    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

    echo <<<JSCRIPT

<script language='JavaScript' type="text/javascript">
<!--
function ckeck_uncheck_all() {
    var frm = document.reglist;
    if(frm.master_box.checked == true){ frm.master_box.checked = false; }
    else{ frm.master_box.checked = true; }
    for (var i=0;i<frm.elements.length;i++) {
        var elmnt = frm.elements[i];
        if (elmnt.type=='checkbox') {
            if(frm.master_box.checked == true){ elmnt.checked=false; }
            else{ elmnt.checked=true; }
        }
    }
}
-->
</script>

JSCRIPT;

    show_footer();
}
else {

    redirect('/?' . RND);
}

?>