<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101))) {

    if (!defined('CFG_FILE')) define( 'CFG_FILE', ENGINE . '/data/config.ini' );

    $cfg = ini::read( CFG_FILE );

    if (!empty($_POST['submit'])) {

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            unset($_POST['submit']);

            $_POST['blog_moder'] = !empty($_POST['blog_moder']) ? 1 : 0;
            $_POST['blog_guest'] = !empty($_POST['blog_guest']) ? 1 : 0;

            foreach($_POST as $key => $val) {

                $cfg[$key] = $val;
            }

            ini::save( CFG_FILE, $cfg );

            $inSes->addMessage('Настройки блога успешно изменены!', 'ok');

            redirect('?m=set&' . RND);
        }
        else {

            $inSes->addMessage('Неверный идентификатор сессии, повторите действие!');
        }
    }

    show_header('Настройки блога');
    $cur_money = moneys($cfg['blog_add_money']);
    $form = new cmsForm('?m=set_blog&amp;rnd=' . $_SESSION['token'], 'post');
    $form->addText('Статей на страницу:', 'blog_num', $cfg['blog_num'], ' size="3"');
    $form->addText('Мин.  символов в статье:', 'blog_min_text', $cfg['blog_min_text'], ' size="3"');
    $form->addText('Макс. символов в статье:', 'blog_max_text', $cfg['blog_max_text'], ' size="5"');
    $form->addCode('<br /><b>За статью в блоге:</b><br />');
    $form->addText('Сколько давать монет (мин 0.01):', 'blog_add_money', $cfg['blog_add_money']);
    $form->addCode('Сейчас ' . $cur_money . '<br />');
    $form->addText('На сколько увеличить авторитет:', 'blog_add_point', num($cfg['blog_add_point']));
    $form->addCode('<br />');
    $form->addText('Разрешить загрузку файлов к статье:', 'blog_upload_file', $cfg['blog_upload_file']);
    $form->addCode('0 - запрещено, 1 - один файл, 2 - два и.т.д...<br />');
    $form->addText('Расширения файлов (если загрузка разрешена):', 'blog_ext_file', $cfg['blog_ext_file']);

    $form->addCheckBox(array('', ' - Модерация статей (вкл/выкл)'), 'blog_moder', num($cfg['blog_moder']));

    $form->addCheckBox(array('', ' Разрешить гостям писать в блоге'), 'blog_guest', num($cfg['blog_guest']));

    echo $form->Submit('Изменить', 'submit');

    unset($form);

    echo '<div class="link"><a href="?m=blog&amp;' . RND . '">Управление</a></div>';
    echo '<div class="link"><a href="?m=set&amp;' . RND . '">Настройки</a></div>';
    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

}
else {

    redirect('/?' . RND);
}

?>