<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101))) {

    if (!defined('CFG_FILE')) define( 'CFG_FILE', ENGINE . '/data/config.ini' );

    $cfg = ini::read( CFG_FILE );

    if (!empty($_POST['submit'])) {

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            unset($_POST['submit']);

            $_POST['chat_guest'] = !empty($_POST['chat_guest']) ? 1 : 0;

            foreach($_POST as $key => $val) {

                $cfg[$key] = $val;
            }

            ini::save( CFG_FILE, $cfg );

            $inSes->addMessage('Настройки чата успешно изменены!', 'ok');

            redirect('?m=set&' . RND);
        }
        else {

            $inSes->addMessage('Неверный идентификатор сессии, повторите действие!');
        }
    }

    show_header('Настройки чата');
    $cur_money = moneys($cfg['chat_add_money']);
    $form = new cmsForm('?m=set_chat&amp;rnd=' . $_SESSION['token'], 'post');

    $form->addText('Автообновление в (сек):', 'chat_refresh', $cfg['chat_refresh'], ' size="3"');

    $form->addText('Время онлайн в (сек):', 'chat_online', $cfg['chat_online'], ' size="3"');

    $form->addText('Сообщений на страницу:', 'chat_num', $cfg['chat_num'], ' size="3"');

    $form->addTextarea('Предупреждение +18+:', 'chat_warning', $cfg['chat_warning']);

    $form->addText('Мин.  символов в сообщении:', 'chat_min_text', $cfg['chat_min_text'], ' size="3"');

    $form->addText('Макс. символов в сообщении:', 'chat_max_text', $cfg['chat_max_text'], ' size="3"');

    $form->addText('Пользователи в чате, через запятую:', 'chat_user_name', $cfg['chat_user_name']);

    $form->addCode('<br /><b>За сообщение в чате:</b><br />');

    $form->addText('Сколько давать монет (мин 0.01):', 'chat_add_money', $cfg['chat_add_money']);

    $form->addCode('Сейчас ' . $cur_money . '<br />');

    $form->addText('На сколько увеличить авторитет:', 'chat_add_ball', num($cfg['chat_add_ball']));

    $form->addCheckBox(array('', ' Разрешить гостям писать в чате'), 'chat_guest', num($cfg['chat_guest']), 1, array('1' => 'ДА', '0' => 'НЕТ'));

    echo $form->Submit('Изменить', 'submit');
    unset($form);

    echo '<div class="link"><a href="?m=set&amp;' . RND . '">Настройки</a></div>';
    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

}
else {

    redirect('/?' . RND);
}

?>