<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101))) {

    if (!defined('CFG_FILE')) define( 'CFG_FILE', ENGINE . '/data/config.ini' );

    $cfg = ini::read( CFG_FILE );

    if ($log == $config['nickname']) {

        $arrthemes = array();
        $globs = glob(THEMES_PATH . '/*', GLOB_ONLYDIR);
        foreach($globs as $glob) $arrthemes[] = basename($glob);
        $arrthemes = array_unique($arrthemes);

        if (!empty($_POST['submit'])) {

            if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

                unset($_POST['submit']);

                $_POST['show_themes'] = !empty($_POST['show_themes']) ? 1 : 0;
                $_POST['share_links'] = !empty($_POST['share_links']) ? 1 : 0;
                $_POST['anti_ads']    = !empty($_POST['anti_ads'])    ? 1 : 0;
                $_POST['show_ads']    = !empty($_POST['show_ads'])    ? 1 : 0;

                foreach($_POST as $key => $val) {

                    $cfg[$key] = $val;
                }

                if (!empty($_SESSION[SP]['themes'])) {

                    $_SESSION[SP]['themes'] = '';
                    unset($_SESSION[SP]['themes']);
                }

                $_SESSION[SP]['themes'] = $cfg['themes'];

                ini::save( CFG_FILE, $cfg );

                $inSes->addMessage('Настройки сайта успешно изменены!', 'ok');

                redirect('?m=set&' . RND);
            }
            else {

                $inSes->addMessage('Неверный идентификатор сессии, повторите действие!');
            }
        }

        show_header('Основные настройки');
        $form = new cmsForm('?m=set_general&amp;rnd=' . $_SESSION['token'], 'post');
        $form->addText('URL сайта:', 'site_url', $cfg['site_url'], ' style="width:100%"');
        $form->addText('Название сайта:', 'site_name', $cfg['site_name'], ' style="width:100%"');
        $form->addText('Заголовок по умолчанию:', 'site_title', $cfg['site_title'], ' style="width:100%"');
        $form->addTextarea('Ключевые слова (через запяую):', 'site_keys', $cfg['site_keys']);
        $form->addTextarea('Описание:', 'site_desc', $cfg['site_desc']);
        $form->addText('Копирайт:', 'site_copy', $cfg['site_copy'], ' style="width:100%"');
        $form->addText('Ключ для паролей:', 'key', $cfg['key']);
        $form->addText('Папка администратора:', 'admin_dir', $cfg['admin_dir']);
        $form->addCode('<span style="blink">[!]</span> после изменения необходимо зайти по FTP и переименовать папку.<br />');

        $form->addText('Время антифлуда (сек):', 'floods_time', $cfg['floods_time']);
        $form->addText('Краткий предпростотр текста:', 'substr_text', $cfg['substr_text']);

        $form->addSelect('Временной сдвиг:', 'time_zone', $cfg['time_zone'], range(-12, 12));
        $form->addSelect('Тема по умолчанию:', 'themes', $cfg['themes'], array_combine($arrthemes,$arrthemes));
        $form->addCheckBox(array('', ' Показ смены тем на главной'), 'show_themes', $cfg['show_themes']);
        $form->addCheckBox(array('', ' Кнопки соц. сетей (вкл/выкл)'), 'share_links', $cfg['share_links']);
        $form->addCheckBox(array('', ' Удалять рекламу с сообщений (чат, блоги, комментарии)'), 'anti_ads', $cfg['anti_ads']);

        $form->addCode('<br /><b>Почта</b><br />');
        $form->addText('Сообщений на стр. в привате:', 'mail_num', $cfg['mail_num'], ' size="3"');
        $form->addText('Макс. кол-во сообщений в привате:', 'limit_mail', $cfg['limit_mail'], ' size="3"');
        $form->addText('Срок хранения удаленных писем (дней):', 'expires_mail', $cfg['expires_mail'], ' size="3"');

        $form->addCode('<br /><b>Реклама</b><br />');
        $form->addText('Сколько показывать ссылок:', 'ads_num', $cfg['ads_num'], ' size="3"');
        $form->addCheckBox(array('', ' Реклама (вкл/выкл)'), 'show_ads', $cfg['show_ads']);

        $form->addCode('<br /><b>Онлайн</b><br />');
        $form->addText('Время (1 мин = 60, 2 = 120 и.т.д):', 'online_time', $cfg['online_time'], ' size="3"');
        $form->addCheckBox(array('', ' Онлайн (вкл/выкл)'), 'allow_online', $cfg['allow_online']);

        echo $form->Submit('Изменить', 'submit');
        unset($form);
        echo '<div class="bl"><span class="blink">[!]</span> <u>Все поля обязательны для заполнения!</u></div>';
        echo '<div class="link"><a href="?m=set&amp;' . RND . '">Настройки</a></div>';
        echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';
    }
    else {

        $inSes->addMessage('Ошибка! Данные настройки доступны только старшему суперадминистратору!');
        redirect('/?' . RND);
    }
}
else {

    redirect('/?' . RND);
}

?>