<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (is_admin(array(101))) {

    if (!defined('CFG_FILE')) define( 'CFG_FILE', ENGINE . '/data/config.ini' );

    $cfg = ini::read( CFG_FILE );

    if (!empty($_POST['submit'])) {

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            unset($_POST['submit']);

            $_POST['allow_reg']       = !empty($_POST['allow_reg'])     ? 1 : 0;
            $_POST['allow_regmail']   = !empty($_POST['allow_regmail']) ? 1 : 0;
            $_POST['add_ban_send']    = !empty($_POST['add_ban_send'])  ? 1 : 0;
            $_POST['allow_cookies']   = !empty($_POST['allow_cookies']) ? 1 : 0;
            $_POST['allow_save_logs'] = !empty($_POST['allow_save_logs'])  ? 1 : 0;
            $_POST['allow_news_user'] = !empty($_POST['allow_news_user']) ? 1 : 0;

            foreach($_POST as $key => $val) {

                $cfg[$key] = $val;
            }

            ini::save( CFG_FILE, $cfg );

            $inSes->addMessage('Настройки успешно изменены!', 'ok');

            redirect('?m=set&' . RND);
        }
        else {

            $inSes->addMessage('Неверный идентификатор сессии, повторите действие!');
        }
    }

    show_header('Настройки регистрации');
    $regkeys   = array('0' => 'Выключить', '1' => 'Автоматически', '2' => 'Вручную');
    $cur_money = moneys($cfg['reg_add_money']);
    $form = new cmsForm('?m=set_reg&amp;rnd=' . $_SESSION['token'], 'post');
    $form->addSelect('Подтверждение регистрации:', 'allow_regkeys', $cfg['allow_regkeys'], $regkeys);
    $form->addCheckBox(array('',' Регистрация открыта'), 'allow_reg', $cfg['allow_reg']);
    $form->addCheckBox(array('',' Регистрация у кого нет E-mail'), 'allow_regmail', $cfg['allow_regmail']);
    $form->addCode('<br /><b>При регистрации:</b><br />');
    $form->addText('Сколько давать монет (мин 0.01):', 'reg_add_money', $cfg['reg_add_money']);
    $form->addCode('Сейчас ' . $cur_money . '<br />');
    $form->addText('На сколько увеличить авторитет:', 'reg_add_score', num($cfg['reg_add_score']));
    $form->addCode('<br /><b>Настройки бана:</b><br />');
    $form->addText('Макс. время бана (сейчас ' . makestime($cfg['max_ban_time']) . '):', 'max_ban_time', $cfg['max_ban_time']);
    $form->addCheckBox(array('',' Разрешить объяснения из бана'), 'add_ban_send', $cfg['add_ban_send']);
    $form->addCode('<br /><b>Остальное:</b><br />');
    $form->addCheckBox(array('',' Вкл. авторизацию по cookies'), 'allow_cookies', $cfg['allow_cookies']);
    $form->addCheckBox(array('',' Вкл. запись авторизаций'), 'allow_save_logs', $cfg['allow_save_logs']);
    echo $form->Submit('Изменить', 'submit');
    unset($form);

    echo '<div class="link"><a href="?m=set&amp;' . RND . '">Настройки</a></div>';
    echo '<div class="link"><a href="?' . RND . '">В админку</a></div>';

}
else {

    redirect('/?' . RND);
}

?>