<?php

if (!defined('CMS')) { die('Access Denied!'); }

if ($is_logged) {

    if ($uset['users_ban'] == 1) {

        if ($uset['users_timeban'] > SITE_TIME) {

            if (!empty($_POST['submit'])) {

                $msg = !empty($_POST['msg']) ? check($_POST['msg']) : '';

                if ($config['add_ban_send'] == 1) {

                  if ($uset['users_explainban'] == 1) {

                    if (cms_strlen($msg) >= 5 && cms_strlen($msg) < 1000) {

                        $is_user = (int) $db->selectCell("SELECT `users_id` FROM ?_users 
                                                          WHERE `users_login` = ? LIMIT 1;", $uset['users_loginsendban']);

                        if ($is_user > 0) {

                            $msg = antimat($msg);
                            $msg = smiles($msg);

                            $priv = 'Объяснение нарушения: ' . $msg;

                            $db->query("INSERT INTO ?_users_inbox (`inbox_user`, `inbox_author`, `inbox_text`, `inbox_time`) 
                                        VALUES (?, ?, ?, ?);", $uset['users_loginsendban'], $log, $textpriv, SITE_TIME);

                            $db->query("UPDATE ?_users SET `users_explainban` = ? WHERE `users_login` = ?;", '0', $log);

                            $db->query("UPDATE ?_users SET `users_newprivat` = (`users_newprivat` + 1) 
                                        WHERE `users_login` = ?;", $uset['users_loginsendban']);

                            $inSes->addMessage('Объяснение успешно отправлено!', 'ok');
                        }
                        else $inSes->addMessage('Ошибка! Пользователь который вас забанил не найден!');
                    }
                    else $inSes->addMessage('Ошибка! Слишком длинное или короткое объяснение!');
                  }
                  else $inSes->addMessage('Ошибка! Вы уже писали объяснение!');
              }
              else $inSes->addMessage('Ошибка! Писать объяснительные запрещено админом!');
            }

            show_header('Бан пользователя');
            echo '<div class="bl"><b>Вас забанили</b><br /><br />';
            echo '<b><span style="color:#ff0000">Причина бана: ' . bb_code($uset['users_reasonban']) . '</span></b><br /><br />';
            echo 'До окончания бана осталось <b>' . formattime($uset['users_timeban'] - SITE_TIME) . '</b><br /></div>';
            echo '<div class="bl">';
            echo 'Чтобы не терять время зря, рекомендуем вам ознакомиться с <b><a href="rules.php">Правилами сайта</a></b><br /></div>';
            echo '<div class="bl">';
            echo 'Общее число строгих нарушений: <b>' . $uset['users_totalban'] . '</b><br />';
            echo 'Внимание, максимальное количество нарушений: <b>5</b><br />';
            echo 'При превышении лимита нарушений ваш профиль автоматически удаляется<br />';
            echo 'Востановление профиля или данных после этого будет невозможным<br />';
            echo 'Будьте внимательны, старайтесь не нарушать больше правил<br /></div>'; 

            if ($config['add_ban_send'] == 1 && $uset['users_explainban'] == 1) {

                $form = new cmsForm();
                $form->addTextarea('Объяснение:', 'msg', request('msg'));
                echo $form->Submit('Отправить','submit');
                unset($form);

                echo '<div class="bl">';
                echo 'Если модер вас забанил по ошибке или вы считаете, что бан не заслужен, то вы можете написать объяснение своего нарушения<br />';
                echo 'В случае если ваше объяснение будет рассмотрено и удовлетворено, то возможно вас и разбанят.</div>';
            }
        }
        else {

            show_header('Бан пользователя');

            echo '<div class="bl"><b>Срок бана закончился!</b><br /><br />';
            echo '<b><span style="color:#ff0000">Причина бана: ' . bb_code($uset['users_reasonban']) . '</span></b><br /></div>';
            echo '<div class="bl">';
            echo 'Поздравляем!!! Время вашего бана вышло, постарайтесь вести себя достойно и не нарушать правила сайта<br /><br />';
            echo 'Рекомендуем ознакомиться с <b><a href="rules.php">Правилами сайта</a></b><br />';
            echo 'Также у вас есть возможность исправиться и снять строгое нарушение.</div>';

            $db->query("UPDATE ?_users SET `users_ban` = '0', `users_timeban` = '0', `users_explainban` = '0' WHERE `users_login` = ?;", $log);
        }
    }
    else {

        $inSes->addMessage('Ошибка! Вы не забанены или срок бана истек!');
        gen_red('index', '', RND);
    }
}
else {

    $inSes->addMessage('Ошибка! Вы не авторизованы!');
    gen_red('index', '', RND);
} 

?>