<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (!empty($id) && array_key_exists($id,$categories)) {

    list($title,$about,$count) = $categories[$id];

    show_header('Раздел: ' . $title, '', $about);

    $onpage = !empty($config['blog_num']) ? num($config['blog_num']) : 10;

    if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

    $rows = array();
    $rows = $db->selectPage($total, "SELECT * FROM ?_blog_posts
                                     WHERE `blog_moders` <> '1' AND `blog_cats_id` = ?
                                     ORDER BY `blog_time` DESC 
                                     LIMIT ?d, ?d", $id, $from, $onpage );

    if (!empty($rows) && $total > 0) {

        foreach($rows as $numRow => $row) {

/*
            if (!empty($row['blog_is_xxx'])) {

                $xxx = ' <span style="color:#ff0000">(18+)</span>';
            }
            else $xxx = '';
*/

            echo ' <a class="links" href="' . gen_uri('post', $row['blog_id'], RND) . '">' . $row['blog_title'] . '<br />';
            echo '<span class="text">' . format_text($row['blog_text']) . '...<br />';
            echo ' Комментарии: <b>' . num($row['blog_comments']);
            echo '</b></span></a>';
        }

        echo show_pages(gen_uri('category', $id, RND));
    }
    else {

        show_error('В разделе пока нет статей!');
    }

    echo '<div class="blocks"><table><tr>';
    echo '<td class="w25"><a href="' . gen_uri('top', '', RND) . '">Топ статей</a></td>';
    echo '<td class="w25"><a href="' . gen_uri('search', '', RND) . '">Поиск</a></td>';
    echo '<td class="w25"><a href="' . gen_uri('category', '', RND) . '">Категории</a></td>';
    echo '<td class="w25"><a href="' . gen_uri('add', '', RND) . '">Написать</a></td></tr></table></div>';

}
else {

    show_header('Разделы блога');

    if (!empty($categories)) {

        foreach( $categories as $key => $val ) {

            list($title,$text,$count) = $val;
			
            echo '<div class="link">';
            echo '<a href="' . gen_uri('category', $key, RND) . '">' . $title . ' <span class="count">' . $count . '</span></a>';
            echo '</div>';
        }
    }
    else {

        show_error('Разделов нет!');
    }

    echo '<div class="blocks"><table><tr>';
    echo '<td class="w25"><a href="' . gen_uri('index', '', RND) . '">Блоги</a></td>';
    echo '<td class="w25"><a href="' . gen_uri('top', '', RND) . '">Топ статей</a></td>';
    echo '<td class="w25"><a href="' . gen_uri('search', '', RND) . '">Поиск</a></td>';
    echo '<td class="w25"><a href="' . gen_uri('add', '', RND) . '">Написать</a></td></tr></table></div>';
}

?>