<?php

if (!defined('CMS')) { die('Access Denied!'); }

if (!empty($id)) {

    $row = array();
    $row = $db->selectRow("SELECT `p`.*, `u`.`users_id` AS `uid`
                           FROM ?_blog_posts `p` LEFT JOIN ?_users `u` 
                           ON `p`.`blog_user` = `u`.`users_login`
                           WHERE `p`.`blog_id` = ? AND `p`.`blog_moders` = '0' LIMIT 1;", $id);

    if (!empty($row)) {

        $cid = intval($row['blog_cats_id']);

        list($title, $about, $count) = $categories[$cid];

        $cat = '<a href="' . $config['site_url'] . '/blog/' . gen_uri('category', $cid, RND) . '">' . $title . '</a>';

        $url = '<a href="' . $config['site_url'] . '/blog/' . gen_uri('post', $id, RND) . '">' . $row['blog_title'] . '</a>';

        $blog = '<a href="' . $config['site_url'] . '/blog/' . gen_uri('index', '', RND) . '">Блоги</a>';

        $date = date('d.m.Y в H:i', $row['blog_time']);

        $row['text'] = nl2br(smiles(bb_code($row['blog_text'])));

        $author = users_anketa($row['uid'], $row['blog_user']);

        header('Content-type:text/html; charset=utf-8');

echo <<<HTML
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<style>
body,td { font-family: verdana, arial, sans-serif; color: #666; font-size: 80%; }
h1,h2,h3,h4 { font-family: verdana, arial, sans-serif; color: #666; font-size: 100%; margin: 0px; }
img {border:0}
</style>
<title>{$config['site_name']} > Версия для печати > {$row['blog_title']}</title>
</head>
<body bgcolor="#ffffff" text="#000000">
<table border="0" width="100%" cellspacing="1" cellpadding="3">
<tr>
<td width="100%">
<a href="{$config['site_url']}">{$config['site_name']}</a> > {$blog} > {$cat} > {$url}
<hr><h1>{$row['blog_title']}</h1><br />
<small>{$date}. Автор: {$author}</small></td>
</tr>
<tr>
<td width="100%">
{$row['text']}<br /><br />
<hr>
<a href="javascript:history.go(-1)">Вернуться назад</a>
</td>
</tr>
</table>
</body>
</html>
HTML;
exit;

    }
    else {

        $inSes->addMessage('Ошибка! Публикация не найдена или временно недоступна!');
        gen_red('index', '', RND);
    }
}
else {

    $onpage = !empty($config['print_num']) ? (int) $config['print_num'] : 25;

    $rows = $db->select("SELECT * FROM ?_blog_posts
                         WHERE `blog_moders` = '0'
                         ORDER BY `blog_time` DESC 
                         LIMIT ?d, ?d", 0, $onpage );
    if (!empty($rows)) {

        header('Content-type:text/html; charset=utf-8');

        $date = date('d.m.Y в H:i', time());

        $new = '<a href="' . $config['site_url'] . '/blog/' . gen_uri('new', '', RND) . '">Новые статьи</a>';

        $blog = '<a href="' . $config['site_url'] . '/blog/' . gen_uri('index', '', RND) . '">Блоги</a>';

echo <<<HTML
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<style>
body,td { font-family: verdana, arial, sans-serif; color: #666; font-size: 80%; }
h1,h2,h3,h4 { font-family: verdana, arial, sans-serif; color: #666; font-size: 100%; margin: 0px; }
img {border:0}
</style>
<title>{$config['site_name']} > Версия для печати > Новые публикации</title>
</head>
<body bgcolor="#ffffff" text="#000000">
<table border="0" width="100%" cellspacing="1" cellpadding="3">
<tr>
<td width="100%">
<a href="{$config['site_url']}">{$config['site_name']}</a> > {$blog} > {$new}
<hr><h1> Новые публикации - {$config['site_name']}</h1>
<small>{$date}</small></td>
</tr>
<tr>
<td width="100%">
HTML;

    $i = 0;
    foreach($rows as $row) {

        echo ++$i . '. <a href="' . $config['site_url'] . '/blog/' . gen_uri('post', $row['blog_id'], RND) . '"><b>' . $row['blog_title'] . '</b></a> (' . date('d.m.Y в H:i', $row['blog_time']) . ')<br />';
        echo nl2br(bb_code($row['blog_text'])) . '<br /><br />';
    }

echo <<<HTML
<hr>
<a href="javascript:history.go(-1)">Вернуться назад</a>
</td>
</tr>
</table>
</body>
</html>
HTML;
exit;


    }
    else {

        $inSes->addMessage('Ошибка! К сожалению блоги временно недоступнены!');
        gen_red('index', '', RND);
    }
}

?>
