<?php

if (!defined('CMS')) { die('Access Denied!'); }

$data = array();
$data = $db->selectRow("SELECT `u`.*,
                       (SELECT COUNT(1) FROM ?_users_wall WHERE `wall_user` = `u`.`users_login`) AS `wall`,
                       (SELECT COUNT(1) FROM ?_blog_posts WHERE `blog_moders` = '0' AND `blog_user` = `u`.`users_login`) AS `blog`,
                       (SELECT `visit_nowtime` FROM ?_users_visit WHERE `visit_user` = `u`.`users_login`) AS `visit`
                        FROM ?_users `u` WHERE `u`.`users_id` = ? LIMIT 1;", $user_id);

if (empty($data) || !is_array($data)) {

    $inSes->addMessage('Ошибка! Пользователь с данным логином не найден!');
    redirect($config['site_url']);
}

if ($data['users_ban'] == 1) {

    $inSes->addMessage('Ошибка! Пользователь заблокирован!');
    redirect($config['site_url']);
}

if ($config['allow_regkeys'] > 0 && $data['users_confirmreg'] > 0) {

    $inSes->addMessage('Ошибка! Пользователя не существует!');
    redirect($config['site_url']);
}

$nickname = nickname($data['users_login']);

show_header('Личка ' . $nickname);

echo '<div class="bl"><table><tr>';
echo '<td style="min-height:35px;;">' . user_avatars($data['users_login']) . '</td>';
echo '<td valign="top" style="padding-left:5px;">';
echo user_visit_icon($data['users_login'], $data['users_gender'], $data['visit']) . ' <b>' . $nickname . ' </b><br />';
echo user_title($data['users_login']) . '</td>';
echo '</tr></table></div>';

echo show_link(gen_uri('anketa', '', RND), 'Анкета');
echo show_link(gen_uri('blogs', '', RND), 'Блоги', num($data['blog']));
echo show_link(gen_uri('wall', '', RND), 'Стена', num($data['wall']));


if ($is_logged && $data['users_login'] == $log) {

    echo '<div class="blocks"><table><tr>';
    echo '<td style="width:50%"><a href="' . gen_users($data['users_id'], 'profil', '', RND) . '">Профиль</a></td>';
    echo '<td style="width:50%"><a href="' . gen_users($data['users_id'], 'setting', '', RND) . '">Настройки</a></td>';
    echo '</tr></table></div>';
}
else {

    if ($is_logged) {

        echo '<div class="link"><a href="' . gen_uri('add_privat', '', 'user=' . $data['users_login']) . '">Отправить сообщение</a></div>';
    }
    else {
        echo '<div class="link"><a href="' . gen_uri('privat', '', RND) . '">Отправить сообщение</a></div>';
    }
}

?>