<?php

if (!defined('CMS')) { die('Access Denied!'); }

if ($is_logged) {

    if (!empty($_GET['clear'])) { // Очистка истории

        if (!empty($_GET['rnd']) && $_GET['rnd'] == $_SESSION['token']) {

            $db->query("DELETE FROM ?_users_login WHERE `login_user` = ?;", $log);

            $db->query("OPTIMIZE TABLE ?_users_login;");

            $inSes->addMessage('История успешно очищена!', 'ok');

            gen_red('logs', '', RND);
        }
        else $inSes->addMessage('Ошибка! Неверный идентификатор сессии, повторите действие!');
    }

    show_header('История входов');

    echo '<div class="bl">Здесь Вы сможете проверить, не заходил ли кто-то чужой под Вашим ником!</div>';

    $onpage = !empty($config['blog_num']) ? num($config['blog_num']) : 10;

    if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

    $rows = $db->selectPage($total, "SELECT * FROM ?_users_login WHERE `login_user` = ?
                                     ORDER BY `login_time` DESC LIMIT ?d, ?d", $log, $from, $onpage);

    if (!empty($rows) && $total > 0) {

        $i = $from + 1;

        foreach ($rows as $numRow => $row) {

            echo '<div class="bl">';
            echo '<b>Дата:</b> ' . get_date($row['login_time']) . '<br />';
            echo '<b>IP-адрес:</b> ' . $row['login_ip'] . '<br />';
            echo '<b>Браузер:</b> ' . $row['login_brow'] . '<br />';
            echo '</div>';
        }

        echo show_pages('logs', '', 'p');

        echo '<div class="link"><a href="?clear=1&amp;rnd=' . $_SESSION['token'] . '">Очистить историю</a></div>';
    }
    else {

        show_error('История входов не найдена!');
    }
}
else {

    show_header('История входов');
    show_login('Вы не авторизованы, чтобы иметь свою историю входов, необходимо');
}

echo '<div class="link"><a href="' . gen_uri('index', '', RND) . '">Назад</a></div>';

?>