<?php

if (!defined('CMS')) { die('Access Denied!'); }

$data = array();
$data = $db->selectRow("SELECT * FROM ?_users WHERE `users_id` = ? LIMIT 1;", $user_id);

if (empty($data) || !is_array($data)) {

    $inSes->addMessage('Ошибка! Пользователь с данным логином не найден!');
    redirect($config['site_url']);
}

if ($data['users_ban'] == 1) {

    $inSes->addMessage('Ошибка! Пользователь заблокирован!');
    redirect($config['site_url']);
}

if ($config['allow_regkeys'] > 0 && $data['users_confirmreg'] > 0) {

    $inSes->addMessage('Ошибка! Пользователя не существует!');
    redirect($config['site_url']);
}

$nickname = nickname($data['users_login']);

show_header('История голосований ' . $nickname);

$onpage = !empty($config['user_list']) ? num($config['user_list']) : 10;

if ($page > 1) $from = ($page - 1) * $onpage; else $from = 0;

$rows = array();
$rows = $db->selectPage($total, "SELECT `r`.*, `v`.`visit_nowtime`, `u`.`users_id`, `u`.`users_gender`
                                 FROM ?_users_rating `r`
                                 LEFT JOIN ?_users_visit `v`
                                 ON `r`.`rating_user` = `v`.`visit_user`
                                 LEFT JOIN ?_users `u`
                                 ON `r`.`rating_user` = `u`.`users_login`
                                 WHERE `r`.`rating_login` = ?
                                 ORDER BY `r`.`rating_time` DESC
                                 LIMIT ?d, ?d", $data['users_login'], $from, $onpage);

if (!empty($rows) && $total > 0) {

    $i = $from + 1;

    foreach ($rows as $numRow => $row) {

        $icon = ($row['rating_vote'] == 1) ? 'up.gif' : 'down.gif';

        echo '<div class="bl"> ';
        echo $i++ .  '. ' . user_visit_icon($row['rating_user'], $row['users_gender'], $row['visit_nowtime']) . ' ';
        echo users_anketa($row['users_id'], $row['rating_user']);
        echo ' (' . get_date($row['rating_time']) . ')<br />';
        echo icon($icon, 'icons') . ' ' . nl2br(bb_code($row['rating_text'])) . '</div>';
    }

    echo show_pages('rating_history', RND, 'p');
}
else {

    show_error('История голосований не найдена!');
}

echo '<div class="link"><a href="' . gen_uri('anketa', '', RND) . '">В анкету</a></div>';
echo '<div class="link"><a href="' . gen_uri('rating', '', RND) . '">Голосовать</a></div>';

?>